--
-- Specialisation for Unimog 406 cabrio
-- 
-- Author: CebuljCek

Vehicle.registerJointType("attachableFrontloader");

Unimog406cabrio = {};

function Unimog406cabrio.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Unimog406cabrio:load(xmlFile)
    self.backHydraulic = {};
	self.backHydraulic.rootArm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#rootArm"));
	self.backHydraulic.bottomArm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#bottomArm"));
	self.frontAttacherJoint = {};
	self.frontAttacherJoint.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.trailerAttacherJoints#front"));
end;

function Unimog406cabrio:delete()
end;

function Unimog406cabrio:readStream(streamId, connection)
end;

function Unimog406cabrio:writeStream(streamId, connection)
end;

function Unimog406cabrio:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Unimog406cabrio:keyEvent(unicode, sym, modifier, isDown)
end;

function Unimog406cabrio:update(dt)
    if self:getIsActive() then
		Cylindered.updateMovingPart(self, self.movingParts[1]);
        
        if self.backHydraulic ~= nil then
			local bHx,bHy,bHz = getRotation(self.backHydraulic.bottomArm);
			local bHBAx,_,_ = getRotation(self.backHydraulic.bottomArm);
			setRotation(self.backHydraulic.rootArm, bHBAx*2.2, bHy, bHz);
		end;
		
        for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
		
	end;
end;

function Unimog406cabrio:updateTick(dt)
end;

function Unimog406cabrio:draw()
end;

function Unimog406cabrio:attachImplement(implement)
end;

function Unimog406cabrio:detachImplement(implementIndex)
end;

function Unimog406cabrio:validateAttacherJoint(implement, jointDesc, dt)
end;

function Unimog406cabrio:onLeave()
end;

function Unimog406cabrio:onEnter()
end;